/****************************************************************************
    NL3W netlist utility for BSch3V
   Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

#include "stdafx.h"
#include "nlist.h"
#include "nlistDlg.h"
#include "cmdlineparam.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNlistApp

BEGIN_MESSAGE_MAP(CNlistApp, CWinApp)
	//{{AFX_MSG_MAP(CNlistApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNlistApp NX̍\z

CNlistApp::CNlistApp()
{
	// TODO: ̈ʒuɍ\zp̃R[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB

	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
//	TCHAR pathModule[_MAX_PATH];
	TCHAR pathExe[_MAX_PATH];


	m_pszIniFileName = new TCHAR[_MAX_PATH];		//pXi[GÅm
												//MFCdeletêŁAŒGAmۂĂ͂ȂB

	//W[̃pX𒲂ׂB
	::GetModuleFileName(NULL,pathExe,_MAX_PATH);

	//Windows 2000/XPɂ
	//\Documents and Settings\username\Local Settings\Application Data\SuigyodoONLINE\NL3W.INI TB
	//ꂪƂ́AINIt@CƂĎgB
	OSVERSIONINFO versionInfo;
	versionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	if(GetVersionEx(&versionInfo)){
		if(versionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT){
			if(SHGetSpecialFolderPath(NULL,m_pszIniFileName,CSIDL_LOCAL_APPDATA,FALSE)){
				TRACE("CBSchApp::CBSchApp() %s\n",m_pszIniFileName);
				lstrcat(m_pszIniFileName,_T("\\SuigyodoONLINE\\NL3W.INI"));
				FILE *pf=_wfopen(m_pszIniFileName,_T("rb"));
				if(pf){
					fclose(pf);
					m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[
					return;
				}
			}
		}
	}

	//ǂɂȂƂɂ̓W[̊i[tH_ INIt@Cg
	//ɂINIt@CȂƂ́AINIt@CVK쐬邪ȀꍇAVK쐬O0xFF,0xFẼt@CĂ
	::_tsplitpath(pathExe,drive,dir,NULL,NULL);
	::_tmakepath_s(m_pszIniFileName,_MAX_PATH,drive,dir,_T("NL3W"),_T(".INI"));
	{
		FILE *pf=_tfopen(m_pszIniFileName,_T("rt"));
		if(pf){
			fclose(pf);
		}else{
			static const byte BOMDATA[2]={0xff,0xfe};
			pf=_tfopen(m_pszIniFileName,_T("wb"));
			if(pf){
				fwrite(BOMDATA,1,2,pf);
				fclose(pf);
			}
		}
	}


	m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[

}

/////////////////////////////////////////////////////////////////////////////
// B CNlistApp IuWFNg

CNlistApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CNlistApp NX̏


BOOL CNlistApp::InitInstance()
{

	ParseCommandLine(m_cmdInfo);

	//AfxEnableControlContainer();

	// WIȏ
	// ̋@\gpAst@C̃TCY
	//  Έȉ̓̏[`̒sKvȂ̂폜
	//  B

#ifdef _AFXDLL
	Enable3dControls();			// L DLL  MFC gꍇ͂R[ĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNꍇ͂R[ĂB
#endif

	// Version 0.69 20101017
	//DLL̓ǂݍ݃pXst@C̃fBNgɐ
	TCHAR moduleFileName[_MAX_PATH];
	TCHAR dllPath[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	::GetModuleFileName(NULL,moduleFileName,_MAX_PATH);
	::_tsplitpath(moduleFileName,drive,dir,NULL,NULL);
	::_tmakepath(dllPath,drive,dir,_T("nl3w_lang"),_T("dll"));
	//܂ Version 0.69 20101017


//ꃊ\[XDLLǂݍޑÕ\[X̃o[Wƃ\[Xnh̕ۑ
	CString strVersion;
	strVersion.LoadString(IDS_VERSION);
	HINSTANCE hInstRcOrg = AfxGetResourceHandle();
	HINSTANCE hInstRc = LoadLibrary( dllPath );
	if ( hInstRc){				// ꃊ\[XDLL.
		AfxSetResourceHandle(hInstRc);
		//ꃊ\[X̃o[W`FbN
		CString strVersionAddRc;
		strVersionAddRc.LoadString(IDS_VERSION);
		//o[WvȂ΁Ã\[Xnhɖ߂
		if(strVersion.Compare(strVersionAddRc)!=0){
			AfxSetResourceHandle(hInstRcOrg);
		}
	}


	//HINSTANCE hInstRc = ::LoadLibrary( "nl3w_lang.dll");
	//if ( hInstRc){				// ꃊ\[XDLL.
	//	AfxSetResourceHandle(hInstRc);
	//}



	//HINSTANCE hDllUserDefNet = LoadLibrary("nl3wpads.dll");
	//int ( __stdcall *DllFunc)(void);

	//if(hDllUserDefNet){
	//	DllFunc = (int(__stdcall*)(void))  ::GetProcAddress( hDllUserDefNet,"fnnl3wpads");
	//	if(DllFunc){
	//		TRACE("DLL function value %d\n",DllFunc());
	//	}
	//}

	//::FreeLibrary(hDllUserDefNet);
	
	//HINSTANCE hDllUserDefNet = LoadLibrary("nlusrfmt.dll");
	//int ( __stdcall *DllFunc)(int,int);
	//void( __stdcall *typeName)(TCHAR*,int);

	//if(hDllUserDefNet){
	//	DllFunc = (int(__stdcall*)(int,int))  ::GetProcAddress( hDllUserDefNet,"testfunc");
	//	if(DllFunc){
	//		TRACE("DLL function value %d\n",DllFunc(10,3));
	//	}

	//	typeName = (void(__stdcall*)(TCHAR*,int)) ::GetProcAddress( hDllUserDefNet,"typeName");
	//	if(typeName){
	//		TCHAR buff[20];
	//		typeName(buff,20);
	//		TRACE("typeName %s\n",buff);
	//	}
	//}

	//::FreeLibrary(hDllUserDefNet);
	


	CNlistDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: _CAO <OK> ŏꂽ̃R[h
		//       LqĂB
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: _CAO <ݾ> ŏꂽ̃R[h
		//       LqĂB
	}

	// _CAOĂAvP[ṼbZ[W |vJńA
	// AvP[VI邽߂ FALSE ԂĂB
	return FALSE;
}
